﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.CodeDom.Compiler;

namespace CodeDOMScriptClass
{
   public partial class Form1 : Form
   {
      private System.CodeDom.CodeCompileUnit m_targetUnit = new System.CodeDom.CodeCompileUnit();
      private System.CodeDom.CodeTypeDeclaration m_targetClass;
      private System.Reflection.MethodInfo m_scriptMethod;
      private Object m_evaluator;

      public Form1()
      {
         InitializeComponent();
      }

      private void create_Click(object sender, EventArgs e)
      {
         Create();
      }

      #region Create
      public void Create()
      {
         System.CodeDom.CodeNamespace samples = new System.CodeDom.CodeNamespace("ASdev");
         samples.Imports.Add(new System.CodeDom.CodeNamespaceImport("System"));
         m_targetClass = new System.CodeDom.CodeTypeDeclaration("ScriptClass");
         m_targetClass.IsClass = true;
         m_targetClass.TypeAttributes = System.Reflection.TypeAttributes.Public | System.Reflection.TypeAttributes.Sealed;
         samples.Types.Add(m_targetClass);
         m_targetUnit.Namespaces.Add(samples);
         createClass();

         System.CodeDom.Compiler.CodeDomProvider provider = System.CodeDom.Compiler.CodeDomProvider.CreateProvider("cs");
         System.CodeDom.Compiler.CompilerParameters parameters;
         parameters = new System.CodeDom.Compiler.CompilerParameters();
         parameters.GenerateInMemory = true;
         parameters.CompilerOptions = "/t:library";

         parameters.ReferencedAssemblies.Add("System.dll");
         parameters.ReferencedAssemblies.Add("System.Windows.Forms.dll");

         System.CodeDom.Compiler.CompilerResults results = provider.CompileAssemblyFromDom(parameters, m_targetUnit);
         if (results.Errors.HasErrors)
            throw new Exception();

         System.Reflection.Assembly assembly = results.CompiledAssembly;
         Type evaluatorType = assembly.GetType("ASdev.ScriptClass");
         m_evaluator = Activator.CreateInstance(evaluatorType);
         m_scriptMethod = evaluatorType.GetMethod("Execute");

         using (System.IO.StringWriter sourceWriter = new System.IO.StringWriter())
         {
            CodeGeneratorOptions options = new System.CodeDom.Compiler.CodeGeneratorOptions();
            options.BracingStyle = "C";
            provider.GenerateCodeFromCompileUnit(m_targetUnit, sourceWriter, options);
            txtCode.Text = sourceWriter.ToString();
               
         }

         provider.Dispose();
      }
      #endregion

      #region createClass
      private void createClass()
      {
         System.CodeDom.CodeConstructor constructor = new System.CodeDom.CodeConstructor();
         constructor.Attributes = System.CodeDom.MemberAttributes.Public | System.CodeDom.MemberAttributes.Final;

         m_targetClass.Members.Add(constructor);
         addMethod(txtScript.Text);
      }
      #endregion

      #region addMethod
      private void addMethod(String script)
      {
         System.CodeDom.CodeMemberMethod mymethod = new System.CodeDom.CodeMemberMethod();
         mymethod.Name = "Execute";

         System.CodeDom.CodeSnippetExpression snippet1 = new System.CodeDom.CodeSnippetExpression(script);
         System.CodeDom.CodeExpressionStatement stmt1 = new System.CodeDom.CodeExpressionStatement(snippet1);
         mymethod.Statements.Add(stmt1);
         mymethod.Attributes = System.CodeDom.MemberAttributes.Public | System.CodeDom.MemberAttributes.Final;
         m_targetClass.Members.Add(mymethod);
      }
      #endregion

      #region Execute
      public void Execute()
      {
         m_scriptMethod.Invoke(m_evaluator, null);
      }
      #endregion

      private void execute_Click(object sender, EventArgs e)
      {
         Execute();
      }
   }
}
